
#include "Premenne.h"
#include "Zdroje.h"
#include "Funkcie.h"



//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////// VLAKNO PROCESU RX USB (OUT) /////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Procedura vlakna
DWORD WINAPI ThreadProc(LPVOID lpParam) 
{
	//Vytvorenie udalosti sledovanej vo vlakne
	ev = CreateEvent(NULL, FALSE, FALSE /*inital state f=nonsignaled*/, NULL);
	memset(&osRead, 0, sizeof(osRead));
	osRead.hEvent = ev;
    if(osRead.hEvent==NULL)
 	{	MessageBox(g_hwndDlg, "Ned sa vytvori objekt udalost.", "Chyba", MB_OK | MB_ICONSTOP);
 		SendMessage(g_hwndDlg, WM_COMMAND, (WPARAM)LOWORD(IDCANCEL), 0);
		return 0;
	}
	//Nekonecny cyklus vlakna, ktore bezi paralelne s cyklom hlavneho programu
	while(StavPripojeniaUSB)
	{	if(!ReadFile(USBhandle, RXbufer, 1+PocetByteUsbIn, &bytesRead, &osRead)) 
			if(GetLastError() != ERROR_IO_PENDING) 
				break;
		//Caka na dalsii prijem bajtov. Po odpojeni zariadenia sa funkcia tiez opusti, ale s chybou. Tym sa opusti while v tomto vlakne.
		if(WaitForSingleObject(ev, INFINITE) != WAIT_OBJECT_0) 
			break;
		SendMessage(g_hwndDlg, WM_RXUSB, 0, 0);
	}	
	//Automaticke odpojenie zariadenie (zatvorenie vstkych handle), ked bolo zariadenie odpojene.
	SendMessage(g_hwndDlg, WM_DISCONNECT, 0, 0);
	return 0;
}





//////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////// HLAVNE OKNO //////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////


//Procedura hlavneho okna
INT_PTR CALLBACK ProceduraDialogu(HWND hwndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   
	//spracovanie sprav adresovanych oknu
    switch(Message)
    {   
    	// definicie a udalosti pri vytvoreni okna
		case WM_INITDIALOG:
        {   //Spristupnenie rukovate hlavneho dialogoveho okna na globalnej urovni.
			g_hwndDlg = hwndDlg;
			//Vytvorenie timeru pre spravu WM_TIMER
			SetTimer(hwndDlg, _Casovac1, _CasTimer1, NULL); 
			//Pozadie hlavneho dialogoveho okna.
			g_pozadieDlg = CreatePatternBrush(LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_POZADIE_DLG2)));
			//Pozadie okienka bitmapy
			g_pozadie = CreatePatternBrush(LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_POZADIE_BMP))); 
			//vlozenie vlastneho kurzoru do okna
			SetClassLong(hwndDlg, GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(ID_CURSOR)));
			//Vlozenie vlastnej ikony do programu
			SetClassLong(hwndDlg, GCL_HICON,(LONG_PTR)LoadIcon(g_hInstance, MAKEINTRESOURCE(ID_ICON)));  
			SetClassLong(hwndDlg, GCL_HICONSM,(LONG_PTR)LoadIcon(g_hInstance, MAKEINTRESOURCE(ID_ICON)));  
			//Tien okna
			SetClassLong(hwndDlg, GCL_STYLE,(LONG_PTR)CS_DROPSHADOW);   			
			//nacitanie vlastneho kurzoru do systemovej triedy "BUTTON"     
		    SetClassLong(GetDlgItem(hwndDlg, ID_BUTTON1), GCL_HCURSOR,(LONG_PTR)LoadCursor(g_hInstance, MAKEINTRESOURCE(ID_CURSOR3)));  
			//Nacitanie obsahu registrov
			ReadRegistry();	
			//Nastavenie polohy a rozmerov hlavneho dialogoveho okna
			SetWindowPos(hwndDlg, HWND_TOP/*HWND_TOPMOST*/, LOWORD(g_dwWindowPos), HIWORD(g_dwWindowPos), _SirkaHlOkna, _VyskaHlOkna, SWP_DRAWFRAME);	
			//Nacitanie obrazkov o pripojenom / odpojenom stave USB
			g_bmp_z = LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_BMP_USB_Z));
			g_bmp_v = LoadBitmap(g_hInstance, MAKEINTRESOURCE(ID_BMP_USB_V));			
			//**************************** VYTVORENIE PAMATOVEJ BITMAPY PRE VYKRESLOVANIE OBSAHU HLAVNEHO OKNA ****************************************
			GetClientRect(hwndDlg, &rect_okna); 
		    HDC hdcScreen = GetDC(hwndDlg); 
		    //vytvorii pamatove HDC kompatibilne s HDC okna
		    g_hdcMemWindow = CreateCompatibleDC(hdcScreen); 
		    ///Vytvori rastrovy obrazok kompatibilny s oknom.
		    HBITMAP hBitmap = CreateCompatibleBitmap(hdcScreen, rect_okna.right, rect_okna.bottom); 
		    SelectObject(g_hdcMemWindow, hBitmap);   
			//Prvotne vyplnenie bitmapy texturou pozadia
		    FillRect(g_hdcMemWindow, &rect_okna, g_pozadie);
		    ReleaseDC(hwndDlg, hdcScreen);
		    DeleteObject(hBitmap);  	
        	//Zobrazenie hlavneho okna, lebo hlavne okno tohoto programu je modalne dialogove okno.
			ShowWindow(hwndDlg, g_nCmdShow); 
			//Vytvorenie suboru pre vypisy Control paketov 
			FILE *fa;
			fa = fopen(NazovSuboru, "w+");	
			fprintf(fa, "Prenos\t\t\tTyp\tPrjemca\tPoiadavka\twValue0\twValue1\t\twLength_LSB\n\n");	
			fclose(fa);
		  	return TRUE;
        }   
        
                
        
        
        //nastavenie pozadia dialogoveho okna a inych jeho prvkov
		//case WM_CTLCOLORLISTBOX:
    	//case WM_CTLCOLOREDIT:
        case WM_CTLCOLORSTATIC:
        //case WM_CTLCOLORDLG:
        {    SetBkMode((HDC)wParam, TRANSPARENT);
             return (INT_PTR)g_pozadieDlg;
        }    
        
 		

	
		// Handler uzivatelsky definovanej spravy zasielanej z procedury vlakna.
		//Tu sa spracuva vsetko, co sa tyka prijatych sprav z USB
		case WM_RXUSB:
		{	if(StavPripojeniaUSB)
			{	//Skopirovanie vsetkych prijatych bajtov z RXbufer[] do pola Cislo[], z ktoreho sa zobrazuje v obsluhe spravy WM_PAINT obsah USB RAM
				memcpy(Cislo, RXbufer,  1+PocetByteUsbIn);	
				// Vypis paketov ControlTransfer do suboru	
				FILE *fa;
				int x;
				fa = fopen(NazovSuboru, "a+");	
				for(x = 1; x <= 60; x += 5)
				{	DWORD test_na_nulu = RXbufer[x+0] + RXbufer[x+1] + RXbufer[x+2] + RXbufer[x+3] + RXbufer[x+4];
					if(test_na_nulu)
					{	
						bmRequestType = RXbufer[x+0], //0b11111111
						SmerTransferu = 0b10000000 & bmRequestType;
						SmerTransferu >>= 7;
						TypTransferu = 0b01100000 & bmRequestType;
						TypTransferu >>= 5;
						PrijemcaTransferu = 0b00011111 & bmRequestType;		
						bRequest = RXbufer[x+1],
						wValue0 = RXbufer[x+2],
						wValue1 = RXbufer[x+3],
						wLength_LSB = RXbufer[x+4];
						PocitadloTransferov++;
						if((SmerTransferu == 1) && (TypTransferu == 0) && (bRequest <= 12 ) && (wValue1 <= 35))		
							fprintf(fa, "%i %s     %s     %s     %s     %i     %s     %i",PocitadloTransferov, SmerT[SmerTransferu], TypT[TypTransferu], PrijemcaT[PrijemcaTransferu], Req[bRequest], wValue0, DescriptorType[wValue1], wLength_LSB);
						else
							fprintf(fa, "%i %s     %s     %s     %s     %i     %i     %i",PocitadloTransferov, SmerT[SmerTransferu], TypT[TypTransferu], PrijemcaT[PrijemcaTransferu], Req[bRequest], wValue0, wValue1, wLength_LSB);
						fprintf(fa, "\n\n");		
					}
				}
				fclose(fa);		
			}			
			RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE);	
			return TRUE;
		}
	
	
	
	
	
		// Odpojenie od USB zariadenia
		case WM_DISCONNECT:
		{	StavPripojeniaUSB = 0; 		 				 
			//Zatvorenie portu
			CloseUSB();
			Adresa = 0;
			int i;
			memset(iProduct, 0, sizeof(iProduct));	
			memset(iManufactured, 0, sizeof(iManufactured));	
			deviceAttributes.ProductID = NULL;
			deviceAttributes.VendorID = NULL;
			deviceAttributes.VersionNumber = NULL;
			// Prekreslenie oblasti okna, kde je "LED indikator" pripojenia
			RedrawWindow(hwndDlg, NULL, NULL, RDW_UPDATENOW | RDW_INVALIDATE);  
			//Pozastavenie cinnosti vlakna
			SuspendThread(ghThread);
			//Vytvorenie timeru pre spravu WM_TIMER, v ktorej sa opakovane pokusa nanovo pripojit k USB zariadeniu
			SetTimer(hwndDlg, _Casovac1, _CasTimer1, NULL); 
			return TRUE;
		}
	
	
	
	
	
	
	
       
		case WM_TIMER:
        {   switch(wParam)
			{	//automaticke pripojenie zariadenia, ked je dostupne.
				case _Casovac1: 
				{	//Ak sa pripojenie podarilo, vytvor vlakno udalosti prijmu z USB a zastav opakovane pokusy o pripajanie
				 	if(StavPripojeniaUSB)        		 
					{	//Vytvorenie vlakna pre udalos prijmu z USB				    				
						ghThread = CreateThread(NULL, 0, ThreadProc, NULL, 0, 0); 	
						//Zastavenie casovaca pre WM_TIMER, kde su zabezpecene opakovane pokusy o pripojenie k zariadeniu.
		 				KillTimer(hwndDlg, _Casovac1);  	
					    //Prekreslenie hlavneho okna
		                RedrawWindow(hwndDlg, NULL, NULL, RDW_UPDATENOW | RDW_INVALIDATE);  
					}
					else 
						//Pokusy o pripajanie k USB zariadeniu, ked je odpojene
						StavPripojeniaUSB = usbOpenDevice(hwndDlg, (VendorId), vendorName, (ProductId), productName, (_VersionNumber));		 
				}
				break;	
			}
			break;
        }  
	

	
	
	
	
	
	
	
	
        	
		case WM_COMMAND:
		{	switch(LOWORD(wParam))
			{	
				if(StavPripojeniaUSB)        		 
				{
					//Tlacitko RESET
					case ID_BUTTON1:
					{	//Naplni vsetky polia nulami
						memset(Cislo, 0, sizeof(Cislo));
						memset(TXbufer, 0, sizeof(TXbufer));
						memset(RXbufer, 0, sizeof(RXbufer));
						//Vymazanie suboru pre vypisy Control paketov
						FILE *fa;
						fa = fopen(NazovSuboru, "w+");	
						fprintf(fa, "Prenos\t\t\tTyp\tPrjemca\tPoiadavka\twValue0\twValue1\t\twLength_LSB\n\n");	
						fclose(fa);	
						fclose(fa);
						TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x03;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);
						PocitadloTransferov = 0;
						// Prekreslenie bitmapy
						RedrawWindow(hwndDlg, &rect_hl, NULL, RDW_UPDATENOW | RDW_INVALIDATE); 	
						break;
					}
					
					//Tlacitko zapni 1
					case ID_BUTTON2:
					{ 	TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x01;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);	
				    	break;
					}
					
					//Vypis paketov do suboru
					case ID_BUTTON3:
					{ 	TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x04;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);	
				    	break;
					}
					
					//Vypis paketov do suboru
					case ID_BUTTON5:
					{ 	system("\"SETUP pakety.txt\"");
				    	break;
					}
					
					//Tlacitko zapni 2
					case ID_BUTTON4:
					{ 	TXbufer[0] = 0x00;				//Musi byt 0x00		  							
						TXbufer[1] = 0x02;			
						DWORD writen;
						WriteFile(USBhandle, TXbufer, 1+PocetByteUsbOut, &writen, &osWrite);	
				    	break;
					}
				             					
				}
			 		
					 
					 			 			 
				// Zatvorenie dialogoveho okna  
				case IDCANCEL:
				{	KillTimer(hwndDlg, _Casovac1);
					CloseUSB();
					WriteRegistry(hwndDlg);
					DeleteDC(g_hdcMemWindow);
					DeleteObject(g_pozadieDlg);
					DeleteObject(g_pozadie);
					CloseHandle(hFile);
					EndDialog(hwndDlg, LOWORD(wParam));
					PostQuitMessage (0);
					//Beep(1100, 100);
					//Beep(800, 200);				
					break;
				}
			 }			
            return TRUE;
        }
        
        
    
       
	   
	   
	   
	   
	   
	   
	   
	    
        
        
        case WM_PAINT: 
        {   PAINTSTRUCT ps;
            HDC hdc;
			SIZE size;
			RECT rect;
			char buffer[1000];
			memset(buffer, 0, sizeof(buffer));
			// Ziskanie handle vykreslovania do okna
            hdc = BeginPaint(hwndDlg, &ps);   
            // Premazanie obsahu bitmapy vyplnou pozadia           
			FillRect(g_hdcMemWindow, &rect_okna, g_pozadie);
								
			//Stanovenie obdlznika kde sa zobrazuju udaje, aby sa pri roznych akciach aktualizoval len ten a neblikali prvky okna
			rect_hl.left = 0;
			rect_hl.right = rect_okna.right;
			rect_hl.top = 40;
			rect_hl.bottom = rect_okna.bottom - 15;
			//rect = RozmeryOkna(hwndDlg);
		
			//Nacitavaqnie cisel 64 bajtov RAM USB z PIC
			int x, y, pozicia = 0;
			for(y = 0; y < 8; y++)
			{	for(x = 0; x < 8; x++)
				{	pozicia++;
					Text(g_hdcMemWindow, &size, "%.2X", Cislo[pozicia], 12+x*30, 40+y*20, RGB(0,0,0), 11, 0, "Segoe UI");	
				}
			}
			

			//======================================= Zobrazenie udajov o zariadeni =======================================================
			int odstup_y = 17, 
				poloha_y = 250,
				poloha_x = 10,
				velkost_pisma = 9;
			COLORREF	farba = RGB(30,70,90);
			//Zobrazenie textoveho deskriptora iManufactured				
			Text(g_hdcMemWindow, &size, "Vendor = ", -1, poloha_x, poloha_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, iManufactured, -1, poloha_x+size.cx, poloha_y, farba, velkost_pisma, 0, "Segoe UI");
			//Zobrazenie textoveho deskriptora iProduct 			
 			Text(g_hdcMemWindow, &size, "Product = ", -1, poloha_x, poloha_y+odstup_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, iProduct, -1, poloha_x+size.cx, poloha_y+odstup_y, farba, velkost_pisma, 0, "Segoe UI");	
			//Zobrazenie VendorID, ProductID a verzie vyrobku
			Text(g_hdcMemWindow, &size, "PID = 0x%.4X", deviceAttributes.ProductID, poloha_x, poloha_y+2*odstup_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, "VID = 0x%.4X", deviceAttributes.VendorID, poloha_x, poloha_y+3*odstup_y, farba, velkost_pisma, 0, "Segoe UI");
			Text(g_hdcMemWindow, &size, "Verzia = 0x%.4X", deviceAttributes.VersionNumber, poloha_x+30+size.cx, poloha_y+3*odstup_y, farba, velkost_pisma, 0, "Segoe UI");
			
											
												
			//Stavova ikonka USB pripojenia         
            if(StavPripojeniaUSB == 1)
            	DrawState(g_hdcMemWindow, 0, 0,(LPARAM)g_bmp_z, 0, rect_okna.right-50-1, 1, 0, 0, DST_BITMAP); 
            else
           		DrawState(g_hdcMemWindow, 0, 0,(LPARAM)g_bmp_v, 0, rect_okna.right-50-1, 1, 0, 0, DST_BITMAP); 
 
           		
 			//skopirovanie obsahu bitmapy do okna        
			BitBlt(hdc, 0,0, rect_okna.right, rect_okna.bottom/*-15*/, g_hdcMemWindow,0,0,SRCCOPY);   
			//ObdlznikZaobleny(hdc, 10, 75, 30, 30, 5, 2, RGB(0,0,0), RGB(255,255,0));
			//Obdlznik(hdc, 10, 75, 30, 30, 2, RGB(0,0,0), RGB(255,255,0));
			//Obluk(hdc, 75, 100, 30, 0, 180, 2, RGB(0,0,0)); 		
			//Usecka(hdc, 50, 95, 70, 30, 2, RGB(0,0,0));
			//Elipsa(hdc, 10, 75, 30, 30, 2, RGB(0,0,0), RGB(255,255,0));	
			//VlastnyTvar(hdc, 70, 75, 50, 30, 2, RGB(0,0,0));
			//VlastnyTvarVyplneny(hdc, 70, 75, 50, 30, 2, RGB(0,0,0), RGB(255,255,0));
			EndPaint(hwndDlg, &ps);       
            return TRUE;
        }    		   
    }
    return FALSE;
}    














// HLAVNY PROGRAM
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) 
{   g_hInstance = hInstance;
	g_nCmdShow = nCmdShow;
	INITCOMMONCONTROLSEX icc;
    icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
    icc.dwICC = ICC_WIN95_CLASSES;
    if ( !InitCommonControlsEx(&icc) )
       return FALSE;      
 	return (int)DialogBox(hInstance, MAKEINTRESOURCE(ID_DIALOG), NULL, (DLGPROC)ProceduraDialogu);	
 	//return (int)CreateDialog(hInstance, MAKEINTRESOURCE(ID_DIALOG), NULL, (DLGPROC)ProceduraDialogu);	
}

